/* This file has been automatically generated by builder part of the ferite distribution */
/* file:  sys_Sys_TcpStream.c */
/* class: TcpStream */

#include <ferite.h>       /* we need this without a doubt */
#include "sys_header.h"  /* this is the module header */

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream_getDescriptor_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 213 "network.fec"

       
           FE_RETURN_LONG((int)SelfObj->filedata);
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream___read___n )
{
   double c;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &c );

   { /* Main function body. */
#line 86 "network.fec"

       
           FeriteVariable *in;
           in = fe_new_str_static("read", NULL, (int)c, FE_CHARSET_DEFAULT);
           FE_STRLEN(in) = read((int)SelfObj->filedata, FE_STR2PTR(in),
                                (int)c);
           if(FE_STRLEN(in) == -1)
           {
               ferite_set_error(script, errno, "%s", strerror(errno));
               FE_STRLEN(in) = 0;
           }
           FE_RETURN_VAR(in);
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream_listen_n )
{
   double backlog;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &backlog );

   { /* Main function body. */
#line 180 "network.fec"

       
           int sock = (int)SelfObj->filedata;
           int retval = listen( sock, (long)backlog );
           FE_RETURN_LONG( retval );
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream_accept_ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 131 "network.fec"

       
           int sock;
           FeriteClass *cls;
           FeriteVariable *fv, *object, **args;
#ifdef ENABLE_IPV6
           int rlen = sizeof(struct sockaddr_in6);
           unsigned char rbuf[sizeof(struct sockaddr_in6)];
#else
           int rlen = sizeof(struct sockaddr_in);
           unsigned char rbuf[sizeof(struct sockaddr_in)];
#endif

           do
           {
               sock = accept((int)SelfObj->filedata, (struct sockaddr *)rbuf,
                             &rlen);
           }
           while(sock == -1 && errno == EINTR);

           if(sock == -1)
           {
               ferite_set_error(script, errno, "%s", strerror(errno));
               FE_RETURN_NULL_OBJECT;
           }

           if((cls = ferite_find_class(script, script->mainns,
                                       "Sys.TcpStream")))
           {
               args = ferite_create_parameter_list(4);
               args = ferite_add_to_parameter_list(args,
                                                   fe_new_lng_static("socket", sock));
               MARK_VARIABLE_AS_DISPOSABLE(args[0]);
               object = ferite_new_object(script, cls, args);
               ferite_delete_parameter_list(script, args);
               fv = ferite_object_get_var(script, self, "af");
               set_remoteip(script, VAO(object), (struct sockaddr *)rbuf,
                            VAI(fv));
               FE_RETURN_VAR(object);
           }
           FE_RETURN_NULL_OBJECT;
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream___close___ )
{
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   { /* Main function body. */
#line 113 "network.fec"

       
           if((int)SelfObj->filedata != -1)
           {
               close((int)SelfObj->filedata);
               (int)SelfObj->filedata = -1;
           }
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream_constructor_n )
{
   double socket;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &socket );

   { /* Main function body. */
#line 75 "network.fec"

       
           FeriteVariable *c = ferite_create_object_variable_with_data( script, "TCPStream", self, FE_STATIC );           
           ferite_variable_destroy( script, ferite_object_call_super(script, c, NULL) );
           ferite_variable_destroy( script, c );
           
           SelfObj->filedata = (void *)(long)socket;
           SelfObj->read = ferite_object_get_function(script, self, "__read__");
           SelfObj->write = ferite_object_get_function(script, self,"__write__");
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream_poll_n )
{
   double sleept;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &sleept );

   { /* Main function body. */
#line 195 "network.fec"

       
           fd_set handles;
           struct timeval tv;
           int i;

           FD_ZERO( &handles );
           FD_SET( (int)SelfObj->filedata, &handles );
           tv.tv_sec = 0;
           tv.tv_usec = sleept;
           while((i = select( (int)SelfObj->filedata + 1, &handles, NULL, NULL, &tv )) == -1 &&
                 errno == EINTR )
             ;
           if( i == -1 )
             ferite_set_error( script, errno, "%s", strerror( errno ) );
           FE_RETURN_LONG( i );
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

FE_NATIVE_FUNCTION( ferite_sys_Sys_TcpStream___write___s )
{
   FeriteString *s;
   FeriteObject *self = FE_CONTAINER_TO_OBJECT;
   FeriteObject *super = FE_CONTAINER_TO_OBJECT;

   ferite_get_parameters( params, 1, &s );

   { /* Main function body. */
#line 100 "network.fec"

       
           int ret;
           ret = write((int)SelfObj->filedata, s->data, s->length);

           if(ret == -1)
           {
               ferite_set_error(script, errno, "%s", strerror(errno));
               ret = 0;
           }
           FE_RETURN_LONG(ret);
       
   }
   FE_RETURN_VOID;
   self = NULL;
   super = NULL;
}

